const assert = require('assert');
const { Given, When, Then } = require('@cucumber/cucumber');

const { fixtures } = require('../../fixtures/server');

const mockValidConfig = fixtures.get('config-valid');
const mockInvalidConfig = fixtures.get('config-invalid');

const mockSchema = require('../../mock/swagger.json');
const { Adapter } = require('../../../dist/adapter');


Given('valid config', function() {
  this.config = mockValidConfig
});

When('the adapter instance is created', function() {
  //let mockProtocol = new GenericProtocol(this.schema);
  let mockAdapter = new Adapter(this.protocol, this.config);
  this.adapter = mockAdapter;
});

When('the auth method is called', async function() {
  await this.adapter.auth();
});

Then('the adapter credentials are populated', function() { 
  assert.equal(this.adapter.credentials.token, fixtures.get('response-valid-token').token);
});

Given('invalid config', function() {
  this.schema = mockSchema;
  this.config = mockInvalidConfig;
});

Then('the adapter auth fails', function() {
  this.adapter.auth()
  .catch((error) => {
    assert.equal(error.response.status, 403);
  });
});