const assert = require('assert');
const { When, Then } = require('@cucumber/cucumber');

const { fixtures } = require('../../fixtures/server');

const mockValidConfig = fixtures.get('config-valid');

When('a mock send API response is configured to return success', function() {
  const response = {};
  this.mockAxios.onPost(
    `${mockValidConfig.api}/send`, 
  ).reply(200, response);
});

When('a mock send API response is configured to return an error', function() {
  this.mockAxios.onPost(
    `${mockValidConfig.api}/send`,
  ).reply(403, { message: 'Token expired' })
});

When('the publish method is called', function() {
  const message = fixtures.get('message-vehicle-status');
  this.message = message;
  const topic = message.metadata.destination;
  const body = JSON.stringify(message);
  this.call = this.adapter.publish(topic, body);
});